您好,登錄后才能下訂單哦!
nagios服務端默認沒有check_nrpe插件,需要編譯安裝nrpe。
nrpe提供check_nrp 以及 nrpe二進制程序和啟動進程所需的配置文件。
對于nagios服務端來說,其只需要check_nrpe插件來發送監控指令,而被監控端則需要通過nrpe進程來監控服務端發送過來的指令(默認監聽5666),并執行本地插件獲取信息,最后回傳給監控端。由此可見,被監控端需要安裝nagios-plugins來獲取插件,但如果被監控端不使用由plugins組件提供的插件,當然也就不需要安裝了。
nrpe的編譯安裝總結:
默認使用用戶nagios和組nagios,最好提前創建
[root@localhost nrpe-2.15]# ./configure --prefix=/mnt #測試目錄 [root@localhost nrpe-2.15]# [root@localhost nrpe-2.15]# make all [root@localhost nrpe-2.15]# make install [root@localhost nrpe-2.15]#
[root@localhost nrpe-2.15]# tree /mnt /mnt ├── bin │ └── nrpe └── libexec └── check_nrpe
已經生成了二進制文件和插件,對于nagios服務端來說,此步之后,直接拷貝check_nrpe到nagios插件存放目錄即可(注意可執行權限)。
而對于被監控端來說,check_nrpe插件是沒有用的,而是需要nrpe來提供監聽服務,但此時安裝目錄并沒有配置文件:
[root@localhost nrpe-2.15]# make install-daemon-config /usr/bin/install -c -m 775 -o nagios -g nagios -d /mnt/etc /usr/bin/install -c -m 644 -o nagios -g nagios sample-config/nrpe.cfg /mnt/etc
可以手動將源碼目錄下的配置文件 sample-config/nrpe.cfg 拷貝到安裝目錄,并修改下屬主和屬組即可。
簡單看下配置文件,需要修改allowed_hosts,將nagios服務端ip添加到后邊,逗號隔開即可:
server_port=5666 #server_address=127.0.0.1 nrpe_user=nagios nrpe_group=nagios allowed_hosts=127.0.0.1,$NagiosIP
有了配置文件就可以啟動nrpe進程了,有兩種方式,一種是獨立守護進程,一種超級守護進程的方式。
獨立守護進程:
[root@localhost nrpe-2.15]# [root@localhost nrpe-2.15]# netstat -antp | grep 5666 [root@localhost nrpe-2.15]# /mnt/bin/nrpe -c /mnt/etc/nrpe.cfg -n -d [root@localhost nrpe-2.15]# netstat -antp | grep 5666 tcp 0 0 0.0.0.0:5666 0.0.0.0:* LISTEN 13643/nrpe tcp 0 0 :::5666 :::* LISTEN 13643/nrpe [root@localhost nrpe-2.15]#
-c 指定配置文件
-n 不使用ssl,默認是使用的,編譯時有參數--enable-ssl可以加上,應該是默認選項
如果使用了 -n, nagios監控端在使用check_nrpe時也需要指定此參數。
-d 已獨立守護進程方式啟動
超級守護進程,需要inetd or xinetd,在編輯相關配置文件時,指定“-i”參數即可。
為了啟動方便,將服務添加到chkconfig
參考腳本:
#!/bin/bash # chkconfig: 35 78 22 LOCK_FILE='/var/lock/subsys/nrped' NRPE_COMMAND='/usr/local/nrpe/bin/nrpe' NRPE_CONFIGURE_FILE='/usr/local/nrpe/etc/nrpe.cfg' start() { echo -n "starting nrped ... " $NRPE_COMMAND -c $NRPE_CONFIGURE_FILE -d &>/dev/null && touch $LOCK_FILE &>/dev/null [[ $? -eq 0 ]] && echo -e "\033[1;32mOK\033[0m" || echo -e "\033[1;31mFAIL\033[0m" } stop() { echo -n "stopping nrped ... " killall nrpe &>/dev/null && rm -f $LOCK_FILE &>/dev/ull [[ $? -eq 0 ]] && echo -e "\033[1;32mOK\033[0m" || echo -e "\033[1;31mFAIL\033[0m" } status() { [[ -f $LOCK_FILE ]] && echo "nrpe is running ..." || echo "nrpe isn't running ... " } case $1 in start) start ;; stop) stop ;; restart) stop; start ;; status) status ;; esac
后期處理和測試:
[root@localhost nrpe-2.15]# chmod +x /etc/init.d/nrped [root@localhost nrpe-2.15]# chkconfig --add nrped [root@localhost nrpe-2.15]# chkconfig --list| grep nrped nrped 0:off 1:off 2:off 3:on 4:off 5:on 6:off [root@localhost nrpe-2.15]# service nrped start starting nrped ... OK [root@localhost nrpe-2.15]# service nrped stop stopping nrped ... OK [root@localhost nrpe-2.15]# service nrped restart stopping nrped ... FAIL starting nrped ... OK [root@localhost nrpe-2.15]# service nrped restart stopping nrped ... OK starting nrped ... OK [root@localhost nrpe-2.15]# service nrped status nrpe is running ... [root@localhost nrpe-2.15]# netstat -antp | grep nrpe tcp 0 0 0.0.0.0:5666 0.0.0.0:* LISTEN 13940/nrpe tcp 0 0 :::5666 :::* LISTEN 13940/nrpe [root@localhost nrpe-2.15]#
關于被監控端插件:
nagios監控端可以“遠程”調用的指令需要在被監控端nrpe配置文件中提前定義,如下:
command[check_users]=/mnt/libexec/check_users -w 5 -c 10 command[check_load]=/mnt/libexec/check_load -w 15,10,5 -c 30,25,20 command[check_hda1]=/mnt/libexec/check_disk -w 20% -c 10% -p /dev/hda1 command[check_zombie_procs]=/mnt/libexec/check_procs -w 5 -c 10 -s Z command[check_total_procs]=/mnt/libexec/check_procs -w 150 -c 200 #command[check_users]=/mnt/libexec/check_users -w $ARG1$ -c $ARG2$ #command[check_load]=/mnt/libexec/check_load -w $ARG1$ -c $ARG2$ #command[check_disk]=/mnt/libexec/check_disk -w $ARG1$ -c $ARG2$ -p $ARG3$ #command[check_procs]=/mnt/libexec/check_procs -w $ARG1$ -c $ARG2$ -s $ARG3$
可以定義閾值明確的指令也可以留有“變量”供監控端指定。
以上指令都是安裝nagios-plugins后生成的指令,現在用shell手動編寫一個簡單的監控插件。
開發插件需要符合以下規則:
插件需要一個返回值和一段輸出,而且nagios只接受第一段輸出。
返回值和nagios五種狀態的對應關系如下:
0: OK
1: WARNNING
2: CRITICAL
3: UNKNOWN
4: PENDING
腳本功能是簡單的監控本地內存, 代碼如下:
#!/bin/bash #Author: LinigYi # "Memory check" OK=0 WARNNING=1 CRITICAL=2 UNKNOWN=3 PENDING=4 mem_string=$(free -m | grep Mem) totle=$(echo $mem_string | awk '{print $2}') used=$(echo $mem_string | awk '{print $3}') free=$(echo $mem_string | awk '{print $4}') used_percent_string=$(echo "scale=3; ${used}/${totle}" | bc) used_percent_aa=${used_percent_string:1:2} used_percent_bb=${used_percent_string:3:1} if [[ $used_percent_bb -ge 5 ]]; then used_percent=$((used_percent_aa+=1)) else used_percent=${used_percent_aa} fi [[ $1 == '-w' ]] && shift && warnning=$1 && shift [[ $1 == '-c' ]] && shift && critical=$1 [[ $warnning -gt $critical ]] && { echo value wrong !! exit $PENDING } if [[ $used_percent -ge $critical ]]; then echo CRITICAL - Totle: $totle Used: $used Free: $free, used percent: ${used_percent}% exit $CRITICAL elif [[ $used_percent -ge $warnning ]]; then echo WARNNING - Totle: $totle Used: $used Free: $free, used percent: ${used_percent}% exit $WARNNING else echo OK - Totle: $totle Used: $used Free: $free, used percent: ${used_percent}% exit $OK fi
基本模擬plugins的插件輸出格式
測試插件:
首先修改配置文件,將nagios服務端ip添加到允許列表:
[root@localhost mnt]# cat /mnt/etc/nrpe.cfg | grep allowed_hosts allowed_hosts=127.0.0.1, 172.19.2.250 [root@localhost mnt]#
[root@localhost mnt]# ls -l /mnt/libexec/ total 240 -rwxr-xr-x. 1 root root 160049 Apr 22 18:10 check_load -rwxr-xr-x. 1 root root 1098 Apr 22 18:14 check_mem -rwxrwxr-x. 1 nagios nagios 76825 Apr 22 16:54 check_nrpe [root@localhost mnt]#
插件一定要有可執行權限! 拷貝一個對比的插件check_load
[root@localhost mnt]# cat /mnt/etc/nrpe.cfg | grep '^command' command_timeout=60 command[check_users]=/mnt/libexec/check_users -w 5 -c 10 command[check_load]=/mnt/libexec/check_load -w 15,10,5 -c 30,25,20 command[check_hda1]=/mnt/libexec/check_disk -w 20% -c 10% -p /dev/hda1 command[check_zombie_procs]=/mnt/libexec/check_procs -w 5 -c 10 -s Z command[check_total_procs]=/mnt/libexec/check_procs -w 150 -c 200 command[check_mem]=/mnt/libexec/check_mem -w 20 -c 40 [root@localhost mnt]#
最后一個 check_mem 指令為自己定義。
啟動nrpe
[root@localhost mnt]# [root@localhost mnt]# killall nrpe [root@localhost mnt]# netstat -antp | grep nrpe [root@localhost mnt]# /mnt/bin/nrpe -c /mnt/etc/nrpe.cfg -d [root@localhost mnt]# netstat -antp | grep nrpe tcp 0 0 0.0.0.0:5666 0.0.0.0:* LISTEN 14831/nrpe tcp 0 0 :::5666 :::* LISTEN 14831/nrpe [root@localhost mnt]#
在nagios服務端做測試:
[root@localhost libexec]# ip add show 1: lo: <LOOPBACK,UP,LOWER_UP> mtu 16436 qdisc noqueue state UNKNOWN link/loopback 00:00:00:00:00:00 brd 00:00:00:00:00:00 inet 127.0.0.1/8 scope host lo inet6 ::1/128 scope host valid_lft forever preferred_lft forever 2: eth0: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 1500 qdisc pfifo_fast state UP qlen 1000 link/ether 00:1a:4a:94:7d:2e brd ff:ff:ff:ff:ff:ff inet 172.19.2.250/24 brd 172.19.2.255 scope global eth0 inet6 fe80::21a:4aff:fe94:7d2e/64 scope link valid_lft forever preferred_lft forever [root@localhost libexec]# [root@localhost libexec]# [root@localhost libexec]# pwd /usr/local/nagios/libexec [root@localhost libexec]# ./check_nrpe -H 192.168.2.162 -c check_load OK - load average: 0.00, 0.00, 0.00|load1=0.000;15.000;30.000;0; load5=0.000;10.000;25.000;0; load15=0.000;5.000;20.000;0; [root@localhost libexec]# [root@localhost libexec]# echo $? 0 [root@localhost libexec]# [root@localhost libexec]# ./check_nrpe -H 192.168.2.162 -c check_mem WARNNING - Totle: 3828 Used: 871 Free: 2956, used percent: 23% [root@localhost libexec]# echo $? 1 [root@localhost libexec]#
檢測成功 !
現在可以在nagios監控端添加監控服務了 !
免責聲明:本站發布的內容(圖片、視頻和文字)以原創、轉載和分享為主,文章觀點不代表本網站立場,如果涉及侵權請聯系站長郵箱:is@yisu.com進行舉報,并提供相關證據,一經查實,將立刻刪除涉嫌侵權內容。